Index: branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/DataGridContentView.Designer.cs
===================================================================
--- branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/DataGridContentView.Designer.cs	(revision 14545)
+++ branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/DataGridContentView.Designer.cs	(revision 14546)
@@ -63,9 +63,14 @@
       this.btnReplace = new System.Windows.Forms.Button();
       this.toolTip = new System.Windows.Forms.ToolTip(this.components);
+      this.uncheckAllButton = new System.Windows.Forms.Button();
+      this.checkAllButton = new System.Windows.Forms.Button();
+      this.checkInputsTargetButton = new System.Windows.Forms.Button();
       this.addRowButton = new System.Windows.Forms.Button();
       this.addColumnButton = new System.Windows.Forms.Button();
       this.renameColumnsButton = new System.Windows.Forms.Button();
+      this.groupBox1 = new System.Windows.Forms.GroupBox();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
       this.contextMenuCell.SuspendLayout();
+      this.groupBox1.SuspendLayout();
       this.SuspendLayout();
       // 
@@ -81,9 +86,4 @@
       this.columnsTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)));
       this.columnsTextBox.Size = new System.Drawing.Size(71, 20);
-      // 
-      // statisticsTextBox
-      // 
-      this.statisticsTextBox.Location = new System.Drawing.Point(3, 387);
-      this.statisticsTextBox.Size = new System.Drawing.Size(421, 13);
       // 
       // btnApplySort
@@ -104,5 +104,5 @@
             this.replaceValueOverSelectionToolStripMenuItem});
       this.contextMenuCell.Name = "contextMenuCell";
-      this.contextMenuCell.Size = new System.Drawing.Size(225, 48);
+      this.contextMenuCell.Size = new System.Drawing.Size(224, 48);
       // 
       // replaceValueOverColumnToolStripMenuItem
@@ -116,5 +116,5 @@
             this.smoothingToolStripMenuItem_Column});
       this.replaceValueOverColumnToolStripMenuItem.Name = "replaceValueOverColumnToolStripMenuItem";
-      this.replaceValueOverColumnToolStripMenuItem.Size = new System.Drawing.Size(224, 22);
+      this.replaceValueOverColumnToolStripMenuItem.Size = new System.Drawing.Size(223, 22);
       this.replaceValueOverColumnToolStripMenuItem.Text = "Replace Value over Column";
       // 
@@ -169,5 +169,5 @@
             this.mostCommonToolStripMenuItem_Selection});
       this.replaceValueOverSelectionToolStripMenuItem.Name = "replaceValueOverSelectionToolStripMenuItem";
-      this.replaceValueOverSelectionToolStripMenuItem.Size = new System.Drawing.Size(224, 22);
+      this.replaceValueOverSelectionToolStripMenuItem.Size = new System.Drawing.Size(223, 22);
       this.replaceValueOverSelectionToolStripMenuItem.Text = "Replace Value over Selection";
       // 
@@ -222,4 +222,37 @@
       this.btnReplace.Click += new System.EventHandler(this.btnReplace_Click);
       // 
+      // uncheckAllButton
+      // 
+      this.uncheckAllButton.Location = new System.Drawing.Point(105, 17);
+      this.uncheckAllButton.Name = "uncheckAllButton";
+      this.uncheckAllButton.Size = new System.Drawing.Size(43, 24);
+      this.uncheckAllButton.TabIndex = 12;
+      this.uncheckAllButton.Text = "None";
+      this.toolTip.SetToolTip(this.uncheckAllButton, "Uncheck all variables");
+      this.uncheckAllButton.UseVisualStyleBackColor = true;
+      this.uncheckAllButton.Click += new System.EventHandler(this.uncheckAllButton_Click);
+      // 
+      // checkAllButton
+      // 
+      this.checkAllButton.Location = new System.Drawing.Point(68, 17);
+      this.checkAllButton.Name = "checkAllButton";
+      this.checkAllButton.Size = new System.Drawing.Size(31, 24);
+      this.checkAllButton.TabIndex = 13;
+      this.checkAllButton.Text = "All";
+      this.toolTip.SetToolTip(this.checkAllButton, "Check all variables");
+      this.checkAllButton.UseVisualStyleBackColor = true;
+      this.checkAllButton.Click += new System.EventHandler(this.checkAllButton_Click);
+      // 
+      // checkInputsTargetButton
+      // 
+      this.checkInputsTargetButton.Location = new System.Drawing.Point(6, 17);
+      this.checkInputsTargetButton.Name = "checkInputsTargetButton";
+      this.checkInputsTargetButton.Size = new System.Drawing.Size(56, 24);
+      this.checkInputsTargetButton.TabIndex = 14;
+      this.checkInputsTargetButton.Text = "Inputs";
+      this.toolTip.SetToolTip(this.checkInputsTargetButton, "Check only inputs and target variable");
+      this.checkInputsTargetButton.UseVisualStyleBackColor = true;
+      this.checkInputsTargetButton.Click += new System.EventHandler(this.checkInputsTargetButton_Click);
+      // 
       // addRowButton
       // 
@@ -252,8 +285,21 @@
       this.renameColumnsButton.Click += new System.EventHandler(this.renameColumnsButton_Click);
       // 
+      // groupBox1
+      // 
+      this.groupBox1.Controls.Add(this.checkInputsTargetButton);
+      this.groupBox1.Controls.Add(this.uncheckAllButton);
+      this.groupBox1.Controls.Add(this.checkAllButton);
+      this.groupBox1.Location = new System.Drawing.Point(426, 0);
+      this.groupBox1.Name = "groupBox1";
+      this.groupBox1.Size = new System.Drawing.Size(160, 49);
+      this.groupBox1.TabIndex = 15;
+      this.groupBox1.TabStop = false;
+      this.groupBox1.Text = "Show Variables";
+      // 
       // DataGridContentView
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.groupBox1);
       this.Controls.Add(this.renameColumnsButton);
       this.Controls.Add(this.addColumnButton);
@@ -263,5 +309,4 @@
       this.Controls.Add(this.btnApplySort);
       this.Name = "DataGridContentView";
-      this.Size = new System.Drawing.Size(430, 403);
       this.Controls.SetChildIndex(this.btnApplySort, 0);
       this.Controls.SetChildIndex(this.btnSearch, 0);
@@ -275,6 +320,8 @@
       this.Controls.SetChildIndex(this.rowsTextBox, 0);
       this.Controls.SetChildIndex(this.columnsTextBox, 0);
+      this.Controls.SetChildIndex(this.groupBox1, 0);
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
       this.contextMenuCell.ResumeLayout(false);
+      this.groupBox1.ResumeLayout(false);
       this.ResumeLayout(false);
       this.PerformLayout();
@@ -304,4 +351,8 @@
     private System.Windows.Forms.Button addColumnButton;
     private System.Windows.Forms.Button renameColumnsButton;
+    private System.Windows.Forms.Button uncheckAllButton;
+    private System.Windows.Forms.Button checkAllButton;
+    private System.Windows.Forms.Button checkInputsTargetButton;
+    private System.Windows.Forms.GroupBox groupBox1;
   }
 }
Index: branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/DataGridContentView.cs
===================================================================
--- branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/DataGridContentView.cs	(revision 14545)
+++ branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/DataGridContentView.cs	(revision 14546)
@@ -686,4 +686,25 @@
       }
     }
+
+    private void checkInputsTargetButton_Click(object sender, EventArgs e) {
+      foreach (DataGridViewColumn column in DataGridView.Columns) {
+        var variable = column.HeaderText;
+        bool isInputTarget = Content.PreProcessingData.InputVariables.Contains(variable)
+          || Content.PreProcessingData.TargetVariable == variable;
+        column.Visible = isInputTarget;
+      }
+    }
+
+    private void checkAllButton_Click(object sender, EventArgs e) {
+      foreach (DataGridViewColumn column in DataGridView.Columns) {
+        column.Visible = true;
+      }
+    }
+
+    private void uncheckAllButton_Click(object sender, EventArgs e) {
+      foreach (DataGridViewColumn column in DataGridView.Columns) {
+        column.Visible = false;
+      }
+    }
   }
 }
Index: branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/StatisticsView.Designer.cs
===================================================================
--- branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/StatisticsView.Designer.cs	(revision 14545)
+++ branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/StatisticsView.Designer.cs	(revision 14546)
@@ -56,4 +56,9 @@
       this.txtMissingValuesTotal = new System.Windows.Forms.Label();
       this.stringMatrixView = new HeuristicLab.Data.Views.StringConvertibleMatrixView();
+      this.groupBox1 = new System.Windows.Forms.GroupBox();
+      this.checkInputsTargetButton = new System.Windows.Forms.Button();
+      this.uncheckAllButton = new System.Windows.Forms.Button();
+      this.checkAllButton = new System.Windows.Forms.Button();
+      this.groupBox1.SuspendLayout();
       this.SuspendLayout();
       // 
@@ -61,5 +66,5 @@
       // 
       this.lblRows.AutoSize = true;
-      this.lblRows.Location = new System.Drawing.Point(3, 11);
+      this.lblRows.Location = new System.Drawing.Point(2, 6);
       this.lblRows.Name = "lblRows";
       this.lblRows.Size = new System.Drawing.Size(34, 13);
@@ -70,5 +75,5 @@
       // 
       this.txtRows.AutoSize = true;
-      this.txtRows.Location = new System.Drawing.Point(115, 11);
+      this.txtRows.Location = new System.Drawing.Point(114, 6);
       this.txtRows.Name = "txtRows";
       this.txtRows.Size = new System.Drawing.Size(19, 13);
@@ -79,5 +84,5 @@
       // 
       this.lblColumns.AutoSize = true;
-      this.lblColumns.Location = new System.Drawing.Point(3, 31);
+      this.lblColumns.Location = new System.Drawing.Point(2, 26);
       this.lblColumns.Name = "lblColumns";
       this.lblColumns.Size = new System.Drawing.Size(47, 13);
@@ -88,5 +93,5 @@
       // 
       this.lblMissingValuesTotal.AutoSize = true;
-      this.lblMissingValuesTotal.Location = new System.Drawing.Point(3, 92);
+      this.lblMissingValuesTotal.Location = new System.Drawing.Point(2, 87);
       this.lblMissingValuesTotal.Name = "lblMissingValuesTotal";
       this.lblMissingValuesTotal.Size = new System.Drawing.Size(100, 13);
@@ -97,5 +102,5 @@
       // 
       this.txtColumns.AutoSize = true;
-      this.txtColumns.Location = new System.Drawing.Point(115, 31);
+      this.txtColumns.Location = new System.Drawing.Point(114, 26);
       this.txtColumns.Name = "txtColumns";
       this.txtColumns.Size = new System.Drawing.Size(25, 13);
@@ -106,5 +111,5 @@
       // 
       this.txtNumericColumns.AutoSize = true;
-      this.txtNumericColumns.Location = new System.Drawing.Point(115, 51);
+      this.txtNumericColumns.Location = new System.Drawing.Point(114, 46);
       this.txtNumericColumns.Name = "txtNumericColumns";
       this.txtNumericColumns.Size = new System.Drawing.Size(25, 13);
@@ -115,5 +120,5 @@
       // 
       this.txtNominalColumns.AutoSize = true;
-      this.txtNominalColumns.Location = new System.Drawing.Point(115, 72);
+      this.txtNominalColumns.Location = new System.Drawing.Point(114, 67);
       this.txtNominalColumns.Name = "txtNominalColumns";
       this.txtNominalColumns.Size = new System.Drawing.Size(25, 13);
@@ -124,5 +129,5 @@
       // 
       this.lblNumericColumns.AutoSize = true;
-      this.lblNumericColumns.Location = new System.Drawing.Point(3, 51);
+      this.lblNumericColumns.Location = new System.Drawing.Point(2, 46);
       this.lblNumericColumns.Name = "lblNumericColumns";
       this.lblNumericColumns.Size = new System.Drawing.Size(89, 13);
@@ -133,5 +138,5 @@
       // 
       this.lblNominalColumns.AutoSize = true;
-      this.lblNominalColumns.Location = new System.Drawing.Point(3, 72);
+      this.lblNominalColumns.Location = new System.Drawing.Point(2, 67);
       this.lblNominalColumns.Name = "lblNominalColumns";
       this.lblNominalColumns.Size = new System.Drawing.Size(88, 13);
@@ -142,5 +147,5 @@
       // 
       this.txtMissingValuesTotal.AutoSize = true;
-      this.txtMissingValuesTotal.Location = new System.Drawing.Point(115, 92);
+      this.txtMissingValuesTotal.Location = new System.Drawing.Point(114, 87);
       this.txtMissingValuesTotal.Name = "txtMissingValuesTotal";
       this.txtMissingValuesTotal.Size = new System.Drawing.Size(25, 13);
@@ -155,11 +160,53 @@
       this.stringMatrixView.Caption = "StringConvertibleMatrix View";
       this.stringMatrixView.Content = null;
-      this.stringMatrixView.Location = new System.Drawing.Point(5, 117);
+      this.stringMatrixView.Location = new System.Drawing.Point(5, 112);
       this.stringMatrixView.Name = "stringMatrixView";
       this.stringMatrixView.ReadOnly = true;
       this.stringMatrixView.ShowRowsAndColumnsTextBox = false;
       this.stringMatrixView.ShowStatisticalInformation = true;
-      this.stringMatrixView.Size = new System.Drawing.Size(530, 278);
+      this.stringMatrixView.Size = new System.Drawing.Size(530, 283);
       this.stringMatrixView.TabIndex = 4;
+      // 
+      // groupBox1
+      // 
+      this.groupBox1.Controls.Add(this.checkInputsTargetButton);
+      this.groupBox1.Controls.Add(this.uncheckAllButton);
+      this.groupBox1.Controls.Add(this.checkAllButton);
+      this.groupBox1.Location = new System.Drawing.Point(212, 3);
+      this.groupBox1.Name = "groupBox1";
+      this.groupBox1.Size = new System.Drawing.Size(160, 49);
+      this.groupBox1.TabIndex = 16;
+      this.groupBox1.TabStop = false;
+      this.groupBox1.Text = "Show Variables";
+      // 
+      // checkInputsTargetButton
+      // 
+      this.checkInputsTargetButton.Location = new System.Drawing.Point(6, 17);
+      this.checkInputsTargetButton.Name = "checkInputsTargetButton";
+      this.checkInputsTargetButton.Size = new System.Drawing.Size(56, 24);
+      this.checkInputsTargetButton.TabIndex = 14;
+      this.checkInputsTargetButton.Text = "Inputs";
+      this.checkInputsTargetButton.UseVisualStyleBackColor = true;
+      this.checkInputsTargetButton.Click += new System.EventHandler(this.checkInputsTargetButton_Click);
+      // 
+      // uncheckAllButton
+      // 
+      this.uncheckAllButton.Location = new System.Drawing.Point(105, 17);
+      this.uncheckAllButton.Name = "uncheckAllButton";
+      this.uncheckAllButton.Size = new System.Drawing.Size(43, 24);
+      this.uncheckAllButton.TabIndex = 12;
+      this.uncheckAllButton.Text = "None";
+      this.uncheckAllButton.UseVisualStyleBackColor = true;
+      this.uncheckAllButton.Click += new System.EventHandler(this.uncheckAllButton_Click);
+      // 
+      // checkAllButton
+      // 
+      this.checkAllButton.Location = new System.Drawing.Point(68, 17);
+      this.checkAllButton.Name = "checkAllButton";
+      this.checkAllButton.Size = new System.Drawing.Size(31, 24);
+      this.checkAllButton.TabIndex = 13;
+      this.checkAllButton.Text = "All";
+      this.checkAllButton.UseVisualStyleBackColor = true;
+      this.checkAllButton.Click += new System.EventHandler(this.checkAllButton_Click);
       // 
       // StatisticsView
@@ -167,4 +214,5 @@
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.groupBox1);
       this.Controls.Add(this.stringMatrixView);
       this.Controls.Add(this.lblNominalColumns);
@@ -180,4 +228,5 @@
       this.Name = "StatisticsView";
       this.Size = new System.Drawing.Size(549, 408);
+      this.groupBox1.ResumeLayout(false);
       this.ResumeLayout(false);
       this.PerformLayout();
@@ -198,4 +247,8 @@
     private System.Windows.Forms.Label txtMissingValuesTotal;
     private HeuristicLab.Data.Views.StringConvertibleMatrixView stringMatrixView;
+    private System.Windows.Forms.GroupBox groupBox1;
+    private System.Windows.Forms.Button checkInputsTargetButton;
+    private System.Windows.Forms.Button uncheckAllButton;
+    private System.Windows.Forms.Button checkAllButton;
   }
 }
Index: branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/StatisticsView.cs
===================================================================
--- branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/StatisticsView.cs	(revision 14545)
+++ branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/StatisticsView.cs	(revision 14546)
@@ -198,23 +198,25 @@
     private void Content_Changed(object sender, DataPreprocessingChangedEventArgs e) {
       UpdateData();
-      //switch (e.Type) {
-      //  case DataPreprocessingChangedEventType.DeleteColumn:
-      //    statisticsMatrix.RemoveAt(e.Column);
-      //    break;
-      //  case DataPreprocessingChangedEventType.AddColumn:
-      //    statisticsMatrix.Insert(e.Row, GetList(e.Column));
-      //    stringMatrixView.Content.Rows++;
-      //    break;
-      //  case DataPreprocessingChangedEventType.ChangeItem:
-      //    statisticsMatrix[e.Column] = GetList(e.Column);
-      //    break;
-      //  case DataPreprocessingChangedEventType.DeleteRow:
-      //  case DataPreprocessingChangedEventType.AddRow:
-      //  default:
-      //    for (int i = 0; i < statisticsMatrix.Count; ++i) {
-      //      statisticsMatrix[i] = GetList(e.Column);
-      //    }
-      //    break;
-      //}
+    }
+
+    private void checkInputsTargetButton_Click(object sender, EventArgs e) {
+      foreach (DataGridViewColumn column in stringMatrixView.DataGridView.Columns) {
+        var variable = column.HeaderText;
+        bool isInputTarget = Content.PreprocessingData.InputVariables.Contains(variable)
+                             || Content.PreprocessingData.TargetVariable == variable;
+        column.Visible = isInputTarget;
+      }
+    }
+
+    private void checkAllButton_Click(object sender, EventArgs e) {
+      foreach (DataGridViewColumn column in stringMatrixView.DataGridView.Columns) {
+        column.Visible = true;
+      }
+    }
+
+    private void uncheckAllButton_Click(object sender, EventArgs e) {
+      foreach (DataGridViewColumn column in stringMatrixView.DataGridView.Columns) {
+        column.Visible = false;
+      }
     }
   }