Index: /branches/TSNE/HeuristicLab.Algorithms.DataAnalysis/3.4/GBM/GradientBoostingRegressionAlgorithm.cs
===================================================================
--- /branches/TSNE/HeuristicLab.Algorithms.DataAnalysis/3.4/GBM/GradientBoostingRegressionAlgorithm.cs	(revision 14557)
+++ /branches/TSNE/HeuristicLab.Algorithms.DataAnalysis/3.4/GBM/GradientBoostingRegressionAlgorithm.cs	(revision 14558)
@@ -52,4 +52,8 @@
       get { return (IRegressionProblem)base.Problem; }
       set { base.Problem = value; }
+    }
+    public override bool SupportsPause
+    {
+      get { return false; }
     }
 
Index: /branches/TSNE/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/GradientBoostedTreesAlgorithm.cs
===================================================================
--- /branches/TSNE/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/GradientBoostedTreesAlgorithm.cs	(revision 14557)
+++ /branches/TSNE/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/GradientBoostedTreesAlgorithm.cs	(revision 14558)
@@ -48,4 +48,8 @@
       set { base.Problem = value; }
     }
+    public override bool SupportsPause
+    {
+      get { return false; }
+    }
 
     #region ParameterNames
Index: /branches/TSNE/HeuristicLab.Algorithms.DataAnalysis/3.4/MctsSymbolicRegression/MctsSymbolicRegressionAlgorithm.cs
===================================================================
--- /branches/TSNE/HeuristicLab.Algorithms.DataAnalysis/3.4/MctsSymbolicRegression/MctsSymbolicRegressionAlgorithm.cs	(revision 14557)
+++ /branches/TSNE/HeuristicLab.Algorithms.DataAnalysis/3.4/MctsSymbolicRegression/MctsSymbolicRegressionAlgorithm.cs	(revision 14558)
@@ -22,5 +22,4 @@
 using System;
 using System.Linq;
-using System.Runtime.CompilerServices;
 using System.Threading;
 using HeuristicLab.Algorithms.DataAnalysis.MctsSymbolicRegression.Policies;
@@ -39,10 +38,16 @@
   [Creatable(CreatableAttribute.Categories.DataAnalysisRegression, Priority = 250)]
   public class MctsSymbolicRegressionAlgorithm : BasicAlgorithm {
-    public override Type ProblemType {
+    public override Type ProblemType
+    {
       get { return typeof(IRegressionProblem); }
     }
-    public new IRegressionProblem Problem {
+    public new IRegressionProblem Problem
+    {
       get { return (IRegressionProblem)base.Problem; }
       set { base.Problem = value; }
+    }
+    public override bool SupportsPause
+    {
+      get { return false; }
     }
 
@@ -68,35 +73,46 @@
 
     #region ParameterProperties
-    public IFixedValueParameter<IntValue> IterationsParameter {
+    public IFixedValueParameter<IntValue> IterationsParameter
+    {
       get { return (IFixedValueParameter<IntValue>)Parameters[IterationsParameterName]; }
     }
-    public IFixedValueParameter<IntValue> MaxVariableReferencesParameter {
+    public IFixedValueParameter<IntValue> MaxVariableReferencesParameter
+    {
       get { return (IFixedValueParameter<IntValue>)Parameters[MaxVariablesParameterName]; }
     }
-    public IFixedValueParameter<BoolValue> ScaleVariablesParameter {
+    public IFixedValueParameter<BoolValue> ScaleVariablesParameter
+    {
       get { return (IFixedValueParameter<BoolValue>)Parameters[ScaleVariablesParameterName]; }
     }
-    public IFixedValueParameter<IntValue> ConstantOptimizationIterationsParameter {
+    public IFixedValueParameter<IntValue> ConstantOptimizationIterationsParameter
+    {
       get { return (IFixedValueParameter<IntValue>)Parameters[ConstantOptimizationIterationsParameterName]; }
     }
-    public IValueParameter<IPolicy> PolicyParameter {
+    public IValueParameter<IPolicy> PolicyParameter
+    {
       get { return (IValueParameter<IPolicy>)Parameters[PolicyParameterName]; }
     }
-    public IFixedValueParameter<DoubleValue> PunishmentFactorParameter {
+    public IFixedValueParameter<DoubleValue> PunishmentFactorParameter
+    {
       get { return (IFixedValueParameter<DoubleValue>)Parameters[PunishmentFactorParameterName]; }
     }
-    public IValueParameter<ICheckedItemList<StringValue>> AllowedFactorsParameter {
+    public IValueParameter<ICheckedItemList<StringValue>> AllowedFactorsParameter
+    {
       get { return (IValueParameter<ICheckedItemList<StringValue>>)Parameters[AllowedFactorsParameterName]; }
     }
-    public IFixedValueParameter<IntValue> SeedParameter {
+    public IFixedValueParameter<IntValue> SeedParameter
+    {
       get { return (IFixedValueParameter<IntValue>)Parameters[SeedParameterName]; }
     }
-    public FixedValueParameter<BoolValue> SetSeedRandomlyParameter {
+    public FixedValueParameter<BoolValue> SetSeedRandomlyParameter
+    {
       get { return (FixedValueParameter<BoolValue>)Parameters[SetSeedRandomlyParameterName]; }
     }
-    public IFixedValueParameter<IntValue> UpdateIntervalParameter {
+    public IFixedValueParameter<IntValue> UpdateIntervalParameter
+    {
       get { return (IFixedValueParameter<IntValue>)Parameters[UpdateIntervalParameterName]; }
     }
-    public IFixedValueParameter<BoolValue> CreateSolutionParameter {
+    public IFixedValueParameter<BoolValue> CreateSolutionParameter
+    {
       get { return (IFixedValueParameter<BoolValue>)Parameters[CreateSolutionParameterName]; }
     }
@@ -104,40 +120,50 @@
 
     #region Properties
-    public int Iterations {
+    public int Iterations
+    {
       get { return IterationsParameter.Value.Value; }
       set { IterationsParameter.Value.Value = value; }
     }
-    public int Seed {
+    public int Seed
+    {
       get { return SeedParameter.Value.Value; }
       set { SeedParameter.Value.Value = value; }
     }
-    public bool SetSeedRandomly {
+    public bool SetSeedRandomly
+    {
       get { return SetSeedRandomlyParameter.Value.Value; }
       set { SetSeedRandomlyParameter.Value.Value = value; }
     }
-    public int MaxVariableReferences {
+    public int MaxVariableReferences
+    {
       get { return MaxVariableReferencesParameter.Value.Value; }
       set { MaxVariableReferencesParameter.Value.Value = value; }
     }
-    public IPolicy Policy {
+    public IPolicy Policy
+    {
       get { return PolicyParameter.Value; }
       set { PolicyParameter.Value = value; }
     }
-    public double PunishmentFactor {
+    public double PunishmentFactor
+    {
       get { return PunishmentFactorParameter.Value.Value; }
       set { PunishmentFactorParameter.Value.Value = value; }
     }
-    public ICheckedItemList<StringValue> AllowedFactors {
+    public ICheckedItemList<StringValue> AllowedFactors
+    {
       get { return AllowedFactorsParameter.Value; }
     }
-    public int ConstantOptimizationIterations {
+    public int ConstantOptimizationIterations
+    {
       get { return ConstantOptimizationIterationsParameter.Value.Value; }
       set { ConstantOptimizationIterationsParameter.Value.Value = value; }
     }
-    public bool ScaleVariables {
+    public bool ScaleVariables
+    {
       get { return ScaleVariablesParameter.Value.Value; }
       set { ScaleVariablesParameter.Value.Value = value; }
     }
-    public bool CreateSolution {
+    public bool CreateSolution
+    {
       get { return CreateSolutionParameter.Value.Value; }
       set { CreateSolutionParameter.Value.Value = value; }
Index: /branches/TSNE/HeuristicLab.Algorithms.DataAnalysis/3.4/TSNE/TSNE.cs
===================================================================
--- /branches/TSNE/HeuristicLab.Algorithms.DataAnalysis/3.4/TSNE/TSNE.cs	(revision 14557)
+++ /branches/TSNE/HeuristicLab.Algorithms.DataAnalysis/3.4/TSNE/TSNE.cs	(revision 14558)
@@ -247,6 +247,8 @@
         if (!plot.Rows.ContainsKey(rowName)) {
           plot.Rows.Add(dataRows.ContainsKey(rowName) ? dataRows[rowName] : new ScatterPlotDataRow(rowName, "", new List<Point2D<double>>()));
-        } else plot.Rows[rowName].Points.Clear();
-        plot.Rows[rowName].Points.AddRange(dataRowLookup[rowName].Select(i => new Point2D<double>(lowDimData[i, 0], lowDimData[i, 1])));
+        }
+        //else plot.Rows[rowName].Points.Clear();
+        plot.Rows[rowName].Points.Replace(dataRowLookup[rowName].Select(i => new Point2D<double>(lowDimData[i, 0], lowDimData[i, 1])));
+        //plot.Rows[rowName].Points.AddRange();
       }
     }
Index: /branches/TSNE/HeuristicLab.Algorithms.DataAnalysis/3.4/TSNE/TSNEAnalysis.cs
===================================================================
--- /branches/TSNE/HeuristicLab.Algorithms.DataAnalysis/3.4/TSNE/TSNEAnalysis.cs	(revision 14557)
+++ /branches/TSNE/HeuristicLab.Algorithms.DataAnalysis/3.4/TSNE/TSNEAnalysis.cs	(revision 14558)
@@ -44,5 +44,8 @@
   [StorableClass]
   public sealed class TSNEAnalysis : BasicAlgorithm {
-
+    public override bool SupportsPause
+    {
+      get { return false; }
+    }
     public override Type ProblemType
     {